package com.example.ivan.ponsi;

import android.content.Context;
import android.database.Cursor;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Date;

/**
 * Created by Ivan on 20/10/2015.
 */
public class AdaptadorTareas extends CursorAdapter {
    private LayoutInflater inflador;
    TextView tipo, titulo,fecha, prova;
    ImageView icono;

    public AdaptadorTareas(Context contexto, Cursor c){
        super(contexto, c, false);
    }

    @Override
    public View newView(Context contexto, Cursor c, ViewGroup padre){
        inflador = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vista = inflador.inflate(R.layout.elemento_lista_tareas, padre,false);
        return vista;
    }

    @Override
    public void bindView(View vista, Context contexto, Cursor c) {

        int a;
        tipo = (TextView) vista.findViewById(R.id.tipotarea_list);
        titulo = (TextView) vista.findViewById(R.id.titulo_list);
        fecha = (TextView) vista.findViewById(R.id.fecha_list);
        icono = (ImageView) vista.findViewById(R.id.icono_tarea_list);

        prova = (TextView) vista.findViewById(R.id.prova);


        a = c.getInt(c.getColumnIndex("tipo_t"));
        titulo.setText(c.getString(c.getColumnIndex("titulo")));
        fecha.setText(DateFormat.getDateInstance().format(new Date(c.getLong(c.getColumnIndex("fecha")))));

        prova.setText(c.getString(c.getColumnIndex("sitio")));

        switch (a){
            case 1:
                tipo.setText("Tratamiento Fitosanitario");
                icono.setImageResource(R.drawable.fito);
                break;
            case 2:
                tipo.setText("Otros");
                icono.setImageResource(R.drawable.otros);
                break;
            case 3:
                tipo.setText("Abonado (Abono solido)");
                icono.setImageResource(R.drawable.abonado);
                break;
            case 4:
                tipo.setText("Riego por goteo");
                icono.setImageResource(R.drawable.goteo);
                break;



        }



        //foto.setScaleType(ImageView.ScaleType.FIT_END);

    }
}


