package com.example.ivan.ponsi;

import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentActivity;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.TimePicker;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by Ivan on 26/10/2015.
 */
public class EditarTareaGoteo extends ActionBarActivity implements TimePickerDialog.OnTimeSetListener, DatePickerDialog.OnDateSetListener{
    private ViewGroup layout, layout_sec, layout_pro;
    LinearLayout nuevoLayout, nuevoLayout2;
    TextView nom,alias,paraje,finca, identificador, identificador_sec, identificador_pro, fecha, fecha_n;
    EditText titulo,observaciones,tiempo,coste, lectura;
    Spinner s_dosis, s_tiempo, s_cantidad, s_abonadora;
    EditText motivo,nom_comer,cantidad,dosis;
    EditText nom_sector, presio, abonadora;
    TextView dias, inicio, fin, elec_dias, hora, hora_num, inicio_num, fin_num;
    CheckBox contador;
    ImageView imag_rel, i_desde, i_hasta;
    long id, idf, idp, ids;
    //int idp, idtt;
    boolean nuevo, des;
    private Tarea tarea = new Tarea();
    private Abonado fito = new Abonado();
    private Sector sector = new Sector();
    private Programa programa = new Programa();
    private ArrayList<Integer>  borrar_pro = new ArrayList<>();
    private ArrayList<Integer> borrar_abo = new ArrayList<>();
    private ArrayList<Integer> borrar_sec = new ArrayList<>();

    SimpleDateFormat formato = new SimpleDateFormat("HH:mm");

    //Variables para la seleccion de los dias
    String dias_elegidos;
    int mes=0;
    CheckBox l,m,x,j,v,s,d;
    DiesFragment newFragment = new DiesFragment();



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.edit_tarea_abono_reg);
        Bundle extras = getIntent().getExtras();
        id = extras.getLong("id", -1);  //id es el identificador de la tabla tares
        nuevo = extras.getBoolean("nuevo", false);
        des = extras.getBoolean("destruido", false);
        //idp = extras.getInt("idp", -1);
        //idtt = extras.getInt("idtt", -1);

        layout = (ViewGroup) findViewById(R.id.l_abono);
        layout_sec = (ViewGroup) findViewById(R.id.l_sectores);


        //Referencio los editext y TextView estaticos
        nom = (TextView) findViewById(R.id.nom_f_t);
        alias = (TextView) findViewById(R.id.alias_f_t);
        paraje = (TextView) findViewById(R.id.paraje_f_t);
        finca = (TextView) findViewById(R.id.finca_f_t);
        titulo = (EditText) findViewById(R.id.titulo_f_t);
        fecha = (TextView) findViewById(R.id.fecha_f_t);
        fecha_n = (TextView) findViewById(R.id.fecha_num);
        observaciones = (EditText) findViewById(R.id.observaciones_f_t);
        tiempo = (EditText) findViewById(R.id.tiempo_f_t);
        coste = (EditText) findViewById(R.id.coste_f_t);
        s_tiempo = (Spinner) findViewById(R.id.stiempo_f_t);
        lectura = (EditText) findViewById(R.id.lectura_c);
        contador = (CheckBox) findViewById(R.id.check_contador);

        if(!nuevo){
           if(!des){
               layout.removeAllViews();
            layout_sec.removeAllViews();
               rellenarvista();}
        }else{
            if(!des){
                layout.removeAllViews();
                layout_sec.removeAllViews();
                rellenarcabecera();}

        }




    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.edicion_cliente, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar:
                cancelar();
                return true;
            case R.id.accion_guardar:

                guardar();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void esNuevo(View view){
        LayoutInflater inflater = LayoutInflater.from(this);

        nuevoLayout = (LinearLayout) inflater.inflate(R.layout.abono_goteo, null, false);

        layout.addView(nuevoLayout);
    }
    public void esNuevoSector(View view){
        LayoutInflater inflater = LayoutInflater.from(this);

        nuevoLayout = (LinearLayout) inflater.inflate(R.layout.sector_goteo, null, false);

        layout_sec.addView(nuevoLayout);
    }
    public void esNuevoPrograma(View view){
        View vista =(View) view.getParent();
        layout_pro = (ViewGroup) vista.findViewById(R.id.l_programa);

        LayoutInflater inflater = LayoutInflater.from(this);

        nuevoLayout2 = (LinearLayout) inflater.inflate(R.layout.programa_goteo, null, false);

        layout_pro.addView(nuevoLayout2);
    }

    public void esQuitar(View view){
       if(!nuevo){
           View vista = (View) view.getParent();
           identificador = (TextView) vista.findViewById(R.id.ida);
           idf = Integer.parseInt(identificador.getText().toString());
           borrar_abo.add((int) idf);
           //ConsultaBD.borrarAbonado((int) idf);
       }
        layout.removeView((View) view.getParent());
    }
    public void esQuitarSector(View view){
        if(!nuevo){
            View vista = (View) view.getParent();
            identificador_sec = (TextView) vista.findViewById(R.id.ids);
            idf = Integer.parseInt(identificador_sec.getText().toString());
            borrar_sec.add((int) idf);
            //ConsultaBD.borrarSector((int) idf);
        }
        layout_sec.removeView((View) view.getParent());
    }
    public void esQuitarPrograma(View view){
        View vista = (View) view.getParent();
        View vista2 = (View) vista.getParent();
        layout_pro = (ViewGroup) vista2.findViewById(R.id.l_programa);

        if(!nuevo){

            identificador_pro = (TextView) vista.findViewById(R.id.idp);
            idf = Integer.parseInt(identificador_pro.getText().toString());
            borrar_pro.add((int) idf);
            //ConsultaBD.borrarPrograma((int) idf);
        }
        layout_pro.removeView(vista);
    }

    public void cancelar(){

        if (getIntent().getExtras().getBoolean("nuevo", false)) {
            ConsultaBD.borrarTarea((int) id);
        }
        finish();
    }

    public void guardar() {
        tarea.setTitulo("" + titulo.getText().toString());
        tarea.setFecha(Float.parseFloat(0 + fecha_n.getText().toString()));
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setTiempo(Float.parseFloat(0 + tiempo.getText().toString()));
        tarea.setCoste(Float.parseFloat(0 + coste.getText().toString()));
        tarea.setsTiempo(s_tiempo.getSelectedItemPosition());

        //borro de la base de datos los sectores, programas y abonos que e eliminado
        for(Integer i: borrar_abo){
            ConsultaBD.borrarAbonado(i);
        }
        for(Integer i: borrar_pro){
            ConsultaBD.borrarPrograma(i);
        }
        for(Integer i: borrar_sec){
            ConsultaBD.borrarSector(i);
        }

        //Para los sectores
        for (int i = 0, count = layout_sec.getChildCount(); i < count; ++i) {
            View view = layout_sec.getChildAt(i);
            //referencio los edittext de los sectores
            nom_sector = (EditText) view.findViewById(R.id.sector_f_g);
            presio = (EditText) view.findViewById(R.id.pres_f_g);
            abonadora = (EditText) view.findViewById(R.id.abonadora_f_g);
            s_abonadora = (Spinner) view.findViewById(R.id.t_abonadora_f_g);
            identificador_sec = (TextView) view.findViewById(R.id.ids);
            layout_pro = (ViewGroup) view.findViewById(R.id.l_programa);

            //Recojo los valores
            sector.setNom("" + nom_sector.getText().toString());
            sector.setPresio(Double.parseDouble(0 + presio.getText().toString()));
            sector.setAbonadora(Integer.parseInt(0 + abonadora.getText().toString()));
            sector.setS_abonadora(s_abonadora.getSelectedItemPosition());



            //acciones de guradar los sectores
            ids = Integer.parseInt(0+identificador_sec.getText().toString());
            if(ids==0){
                ids = ConsultaBD.nuevoSector((int) id, sector);//nueva ficha
            }else{

                ConsultaBD.actualiarSector((int) ids, sector);
            }

            //para los programas
            for (int j = 0, countj = layout_pro.getChildCount(); j < countj; ++j) {
                View view2 = layout_pro.getChildAt(j);

                //referencias de los programas
                dias = (TextView) view2.findViewById(R.id.dias_f_p);
                inicio = (TextView) view2.findViewById(R.id.desde);
                fin = (TextView) view2.findViewById(R.id.hasta);
                identificador_pro =  (TextView) view2.findViewById(R.id.idp);

                //recojo los valores
                programa.setDias("" + dias.getText().toString());
                programa.setInicio(Long.parseLong(0 + inicio.getText().toString()));
                programa.setFin(Long.parseLong(0 + fin.getText().toString()));


                //acciones de guardar los programas

                    idp = Integer.parseInt(0+identificador_pro.getText().toString());//si no existe sera 0

                    if(idp==0){
                        ConsultaBD.nuevoPrograma((int) ids, programa);//nueva ficha
                    }else{
                    ConsultaBD.actualiarPrograma((int) idp, programa);
                    }



            }

        }


        //Para los abonos
        for (int i = 0, count = layout.getChildCount(); i < count; ++i) {
            View view = layout.getChildAt(i);

            //Referencio los editext del layout dinamico
            motivo = (EditText) view.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) view.findViewById(R.id.nombre_abo);
            cantidad = (EditText) view.findViewById(R.id.cantidad_abo);
            dosis = (EditText) view.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) view.findViewById(R.id.s_dosis_a);
            s_cantidad = (Spinner) view.findViewById(R.id.tcantidad_abo);
            identificador = (TextView) view.findViewById(R.id.ida);

            //Recojo los valores introducidos
            fito.setMotivo("" + motivo.getText().toString());
            fito.setNombre("" + nom_comer.getText().toString());
            fito.setCantidad(Double.parseDouble(0 + cantidad.getText().toString()));
            fito.setDosis(Double.parseDouble(0 + dosis.getText().toString()));
            fito.setsDosis(s_dosis.getSelectedItemPosition());
            fito.setT_cantidad(s_cantidad.getSelectedItemPosition());

            //Toast.makeText(EditarTareaGoteo.this,"tarea = "+id+ " dosis = " + s_dosis.getSelectedItemPosition() +" cantidad = "+s_cantidad.getSelectedItemPosition(), Toast.LENGTH_LONG).show();


            //Guardo los valores en la base de datos
            idf = Integer.parseInt(0+identificador.getText().toString());
            if(idf==0){
                ConsultaBD.nuevoAbonado((int)id,fito);//nueva ficha
             }else{
                idf = Integer.parseInt(identificador.getText().toString());
                ConsultaBD.actualiarAbonado((int) idf, fito);
            }





        }

        //guardo el contador
        if (nuevo){
        ConsultaBD.nuevaLectura((int)id,(int)Integer.parseInt(0+lectura.getText().toString()), contador.isChecked());
        }else{
            ConsultaBD.actualizarLectura((int)id,(int)Integer.parseInt(0+lectura.getText().toString()), contador.isChecked());
        }

        ConsultaBD.actualizarTarea((int)id,tarea);

        finish();
    }
    public void guardar2() {
        tarea.setTitulo("" + titulo.getText().toString());
        tarea.setFecha(Float.parseFloat(0 + fecha_n.getText().toString()));
        tarea.setObservaciones("" + observaciones.getText().toString());
        tarea.setTiempo(Float.parseFloat(0 + tiempo.getText().toString()));
        tarea.setCoste(Float.parseFloat(0 + coste.getText().toString()));
        tarea.setsTiempo(s_tiempo.getSelectedItemPosition());

        //borro de la base de datos los sectores, programas y abonos que e eliminado
        for(Integer i: borrar_abo){
            ConsultaBD.borrarAbonado(i);
            borrar_abo = new ArrayList<>();
        }
        for(Integer i: borrar_pro){
            ConsultaBD.borrarPrograma(i);

        }
        for(Integer i: borrar_sec){
            ConsultaBD.borrarSector(i);
        }

        //Para los sectores
        for (int i = 0, count = layout_sec.getChildCount(); i < count; ++i) {
            View view = layout_sec.getChildAt(i);
            //referencio los edittext de los sectores
            nom_sector = (EditText) view.findViewById(R.id.sector_f_g);
            presio = (EditText) view.findViewById(R.id.pres_f_g);
            abonadora = (EditText) view.findViewById(R.id.abonadora_f_g);
            s_abonadora = (Spinner) view.findViewById(R.id.t_abonadora_f_g);
            identificador_sec = (TextView) view.findViewById(R.id.ids);
            layout_pro = (ViewGroup) view.findViewById(R.id.l_programa);

            //Recojo los valores
            sector.setNom("" + nom_sector.getText().toString());
            sector.setPresio(Double.parseDouble(0 + presio.getText().toString()));
            sector.setAbonadora(Integer.parseInt(0 + abonadora.getText().toString()));
            sector.setS_abonadora(s_abonadora.getSelectedItemPosition());



            //acciones de guradar los sectores
            ids = Integer.parseInt(0+identificador_sec.getText().toString());
            if(ids==0){
                ids = ConsultaBD.nuevoSector((int) id, sector);//nueva ficha
            }else{

                ConsultaBD.actualiarSector((int) ids, sector);
            }

            //para los programas
            for (int j = 0, countj = layout_pro.getChildCount(); j < countj; ++j) {
                View view2 = layout_pro.getChildAt(j);

                //referencias de los programas
                dias = (TextView) view2.findViewById(R.id.dias_f_p);
                inicio = (TextView) view2.findViewById(R.id.desde);
                fin = (TextView) view2.findViewById(R.id.hasta);
                identificador_pro =  (TextView) view2.findViewById(R.id.idp);

                //recojo los valores
                programa.setDias("" + dias.getText().toString());
                programa.setInicio(Long.parseLong(0 + inicio.getText().toString()));
                programa.setFin(Long.parseLong(0 + fin.getText().toString()));


                //acciones de guardar los programas

                idp = Integer.parseInt(0+identificador_pro.getText().toString());//si no existe sera 0

                if(idp==0){
                    ConsultaBD.nuevoPrograma((int) ids, programa);//nueva ficha
                }else{
                    ConsultaBD.actualiarPrograma((int) idp, programa);
                }



            }

        }


        //Para los abonos
        for (int i = 0, count = layout.getChildCount(); i < count; ++i) {
            View view = layout.getChildAt(i);

            //Referencio los editext del layout dinamico
            motivo = (EditText) view.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) view.findViewById(R.id.nombre_abo);
            cantidad = (EditText) view.findViewById(R.id.cantidad_abo);
            dosis = (EditText) view.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) view.findViewById(R.id.s_dosis_a);
            s_cantidad = (Spinner) view.findViewById(R.id.tcantidad_abo);
            identificador = (TextView) view.findViewById(R.id.ida);

            //Recojo los valores introducidos
            fito.setMotivo("" + motivo.getText().toString());
            fito.setNombre("" + nom_comer.getText().toString());
            fito.setCantidad(Double.parseDouble(0 + cantidad.getText().toString()));
            fito.setDosis(Double.parseDouble(0 + dosis.getText().toString()));
            fito.setsDosis(s_dosis.getSelectedItemPosition());
            fito.setT_cantidad(s_cantidad.getSelectedItemPosition());

            //Toast.makeText(EditarTareaGoteo.this,"tarea = "+id+ " dosis = " + s_dosis.getSelectedItemPosition() +" cantidad = "+s_cantidad.getSelectedItemPosition(), Toast.LENGTH_LONG).show();


            //Guardo los valores en la base de datos
            idf = Integer.parseInt(0+identificador.getText().toString());
            if(idf==0){
                ConsultaBD.nuevoAbonado((int)id,fito);//nueva ficha
            }else{
                idf = Integer.parseInt(identificador.getText().toString());
                ConsultaBD.actualiarAbonado((int) idf, fito);
            }





        }

        //guardo el contador
        if (nuevo){
            ConsultaBD.nuevaLectura((int)id,(int)Integer.parseInt(0+lectura.getText().toString()), contador.isChecked());
        }else{
            ConsultaBD.actualizarLectura((int)id,(int)Integer.parseInt(0+lectura.getText().toString()), contador.isChecked());
        }

        ConsultaBD.actualizarTarea((int) id, tarea);


    }

    public void elegirdias(View view){
        elec_dias = (TextView) view.findViewById(R.id.dias_f_p);

        newFragment.show(getSupportFragmentManager(), "Elegir Dias");
    }

    public void Lunes(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);
        l.setChecked(!l.isChecked());
    }
    public void Martes(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);
        m.setChecked(!m.isChecked());
    }
    public void Miercoles(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);
        x.setChecked(!x.isChecked());
    }
    public void Jueves(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);
        j.setChecked(!j.isChecked());
    }
    public void Viernes(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);
        v.setChecked(!v.isChecked());
    }
    public void Sabado(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);
        s.setChecked(!s.isChecked());

    }
    public void Domingo(View view){
        //me situo en el layout padre
        View vista2 =(View) view.getParent();


        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);

        d.setChecked(!d.isChecked());

    }

    public void todos(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);

        l.setChecked(true);
        m.setChecked(true);
        x.setChecked(true);
        j.setChecked(true);
        v.setChecked(true);
        s.setChecked(true);
        d.setChecked(true);

    }
    public void ninguno(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);

        l.setChecked(false);
        m.setChecked(false);
        x.setChecked(false);
        j.setChecked(false);
        s.setChecked(false);
        d.setChecked(false);
        v.setChecked(false);

    }


    public void aceptar(View view){
        //me situo en el layout padre
        View vista =(View) view.getParent();
        View vista2 =(View) vista.getParent();

        //Referencio los checkbox de los dias
        l = (CheckBox)vista2.findViewById(R.id.c_lunes);
        m = (CheckBox)vista2.findViewById(R.id.c_martes);
        x = (CheckBox)vista2.findViewById(R.id.c_miercoles);
        j = (CheckBox)vista2.findViewById(R.id.c_jueves);
        v = (CheckBox)vista2.findViewById(R.id.c_viernes);
        s = (CheckBox)vista2.findViewById(R.id.c_sabado);
        d = (CheckBox)vista2.findViewById(R.id.c_domingo);

        dias_elegidos="";
        if(l.isChecked()){
            dias_elegidos = "Lunes";
            mes=1;
        }

        if(m.isChecked()){
            if(mes==1){
                dias_elegidos = dias_elegidos+", ";
                mes=0;
            }
            dias_elegidos = dias_elegidos+"Martes";
            mes=1;
        }

        if(x.isChecked()){
            if(mes==1){
                dias_elegidos = dias_elegidos+", ";
                mes=0;
            }
            dias_elegidos = dias_elegidos+"Miercoles";
            mes=1;
        }

        if(j.isChecked()){
            if(mes==1){
                dias_elegidos = dias_elegidos+", ";
                mes=0;
            }
            dias_elegidos = dias_elegidos+"Jueves";
            mes=1;
        }

        if(v.isChecked()){
            if(mes==1){
                dias_elegidos = dias_elegidos+", ";
                mes=0;
            }
            dias_elegidos = dias_elegidos+"Viernes";
            mes=1;
        }

        if(s.isChecked()){
            if(mes==1){
                dias_elegidos = dias_elegidos+", ";
                mes=0;
            }
            dias_elegidos = dias_elegidos+"Sabado";
            mes=1;
        }

        if(d.isChecked()){
            if(mes==1){
                dias_elegidos = dias_elegidos+", ";
                mes=0;
            }
            dias_elegidos = dias_elegidos+"Domingo";
            mes=1;
        }
        mes=0;


        elec_dias.setText(dias_elegidos);
        newFragment.dismiss();


    }




    public void elegirFecha(View view){
        hora =(TextView) view.findViewById(R.id.fecha_f_t);
        hora_num = (TextView)view.findViewById(R.id.fecha_num);
        DatePickerFragment newFragment = new DatePickerFragment();
        newFragment.setEscuchador(this);
        newFragment.show(getSupportFragmentManager(), "Elegir fecha");

    }
    public void elegirHasta(View view){
        hora =(TextView) view.findViewById(R.id.hora2_f_p);
        hora_num = (TextView)view.findViewById(R.id.hasta);
        imag_rel = (ImageView) view.findViewById(R.id.imag_hasta);
        TimePickerFragment dialog = new TimePickerFragment();
        dialog.setOnTimeSetListener(this);
        dialog.show(getSupportFragmentManager(), "Selecione hora");

    }

    public void elegirDesde(View view){
        hora =(TextView) view.findViewById(R.id.hora1_f_p);
        hora_num = (TextView)view.findViewById(R.id.desde);
        imag_rel = (ImageView) view.findViewById(R.id.imag_desde);
        TimePickerFragment dialog = new TimePickerFragment();
        dialog.setOnTimeSetListener(this);
        dialog.show(getSupportFragmentManager(), "Selecione hora");

    }

    @Override
    public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
        // Do something with the time chosen by the user
        Calendar calendario = Calendar.getInstance();
        calendario.set(Calendar.HOUR_OF_DAY, hourOfDay);
        calendario.set(Calendar.MINUTE, minute);
        long valor = calendario.getTimeInMillis();
        mostrarhora(valor);
    }

    public void onDateSet(DatePicker view, int year, int month, int day) {
        // Do something with the date chosen by the user
        Calendar calendario = Calendar.getInstance();
        calendario.set(year,month,day);
        long valor = calendario.getTimeInMillis();
        mostrarfecha(valor);

    }

    public void mostrarhora(long num){
        SimpleDateFormat formato = new SimpleDateFormat("HH:mm");
        hora.setText(formato.format(new Date(num)));
        hora_num.setText(Long.toString(num));
        imag_rel.setVisibility(View.GONE);


    }

    public void mostrarfecha(long num){


        hora.setText(DateFormat.getDateInstance().format(new Date(num)));
        hora_num.setText(Long.toString(num));

    }

    public void rellenarcabecera(){

        tarea = ConsultaBD.TareaVacia((int)id);

        if(tarea != null) {

            nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
            finca.setText(tarea.getFinca());
        }
    }

    public void rellenarvista(){

        tarea = ConsultaBD.Tarea((int) id);

        if(tarea != null){

            nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
            finca.setText(tarea.getFinca());
            titulo.setText(tarea.getTitulo());
            if(tarea.getFecha()!=0){
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
                fecha_n.setText(Float.toString(tarea.getFecha()));
            }
            observaciones.setText(tarea.getObservaciones());
            if(tarea.getTiempo()!=0){
                tiempo.setText(Double.toString(tarea.getTiempo()));
            }
            if(tarea.getCoste()!=0){
                coste.setText(Double.toString(tarea.getCoste()));
            }
            s_tiempo.setSelection(tarea.getsTiempo());

        }

        //Implemento los sectores
        Cursor c1 = ConsultaBD.listadoSectores((int) id);

        while(c1.moveToNext()){
            //creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.sector_goteo, null, false);

            //Referencio los textview
            nom_sector = (EditText) nuevoLayout.findViewById(R.id.sector_f_g);
            presio = (EditText) nuevoLayout.findViewById(R.id.pres_f_g);
            abonadora = (EditText) nuevoLayout.findViewById(R.id.abonadora_f_g);
            s_abonadora =(Spinner) nuevoLayout.findViewById(R.id.t_abonadora_f_g);
            layout_pro =   (ViewGroup) nuevoLayout.findViewById(R.id.l_programa);
            identificador_sec = (TextView) nuevoLayout.findViewById(R.id.ids);
            //Pongo el texto en los textview
            int val;
            Double valor;
            nom_sector.setText(c1.getString(c1.getColumnIndex("n_sector")));
            valor=c1.getDouble(c1.getColumnIndex("presio"));
            if(valor!=0) {
                presio.setText(Double.toString(valor));
            }
            val =c1.getInt(c1.getColumnIndex("abonadora"));
            if(val!=0) {
                abonadora.setText(Integer.toString(val));
            }
            s_abonadora.setSelection(c1.getInt(c1.getColumnIndex("t_abonadora")));
            identificador_sec.setText(Integer.toString(c1.getInt(c1.getColumnIndex("sector_id"))));
            ids = c1.getInt(c1.getColumnIndex("sector_id"));

            //Implemento los programas
            Cursor c2 = ConsultaBD.listadoProgramas((int)ids);

            while(c2.moveToNext()){
                //creo el layout del programa
                LayoutInflater inflater2 = LayoutInflater.from(this);
                nuevoLayout2 = (LinearLayout) inflater2.inflate(R.layout.programa_goteo, null, false);

                // Referencio los textView
                dias = (TextView) nuevoLayout2.findViewById(R.id.dias_f_p);
                inicio = (TextView) nuevoLayout2.findViewById(R.id.hora1_f_p);
                fin = (TextView) nuevoLayout2.findViewById(R.id.hora2_f_p);
                inicio_num = (TextView) nuevoLayout2.findViewById(R.id.desde);
                fin_num = (TextView) nuevoLayout2.findViewById(R.id.hasta);
                i_desde = (ImageView) nuevoLayout2.findViewById(R.id.imag_desde);
                i_hasta = (ImageView) nuevoLayout2.findViewById(R.id.imag_hasta);
                identificador_pro = (TextView) nuevoLayout2.findViewById(R.id.idp);

                //pongo el texto el los textviews
                long valo;
                dias.setText(c2.getString(c2.getColumnIndex("dias")));
                valo = c2.getLong(c2.getColumnIndex("desde"));
                if(valo!=0){
                    i_desde.setVisibility(View.GONE);
                    inicio.setText(formato.format(new Date(valo)) + " ");
                }

                valo = c2.getLong(c2.getColumnIndex("hasta"));
                if(valo!=0){
                    i_hasta.setVisibility(View.GONE);
                    fin.setText(formato.format(new Date(valo)) + " ");
                }

                inicio_num.setText(Long.toString(0+c2.getLong(c2.getColumnIndex("desde"))));
                fin_num.setText(Long.toString(0+c2.getLong(c2.getColumnIndex("hasta"))));
                identificador_pro.setText(Integer.toString(c2.getInt(c2.getColumnIndex("programa_id"))));

                //añado el layout a la vista
                layout_pro.addView(nuevoLayout2);

            }
            c2.close();

            //añado el layout a la vista
            layout_sec.addView(nuevoLayout);



        }

        c1.close();

        /*A continuacion se rellenan los abonos utilizados*/
        Cursor c = ConsultaBD.listadoAbonado((int) id);

        while(c.moveToNext()){
            //Creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.abono_goteo, null, false);

            //Referencio los textview
            motivo = (EditText) nuevoLayout.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) nuevoLayout.findViewById(R.id.nombre_abo);
            cantidad = (EditText) nuevoLayout.findViewById(R.id.cantidad_abo);
            dosis = (EditText) nuevoLayout.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) nuevoLayout.findViewById(R.id.s_dosis_a);
            s_cantidad = (Spinner) nuevoLayout.findViewById(R.id.tcantidad_abo);
            identificador = (TextView) nuevoLayout.findViewById(R.id.ida);

            //Pongo el texto en los TextView
            Double valor;
            identificador.setText(Integer.toString(c.getInt(c.getColumnIndex("abonado_id"))));
            motivo.setText(c.getString(c.getColumnIndex("motivo")));
            nom_comer.setText(c.getString(c.getColumnIndex("nombre_a")));
            valor=c.getDouble(c.getColumnIndex("cantidad"));
            if(valor!=0){
                cantidad.setText(Double.toString(valor));
            }
            valor =c.getDouble(c.getColumnIndex("dosis"));
            if(valor!=0){
                dosis.setText(Double.toString(valor));
            }
            s_dosis.setSelection(c.getInt(c.getColumnIndex("dosis_s")));
            s_cantidad.setSelection(c.getInt(c.getColumnIndex("t_cantidad")));

            //Añado el Layout a la vista
            layout.addView(nuevoLayout);


        }

    }
    public void rellenarvista2(){

        tarea = ConsultaBD.Tarea((int) id);

        if(tarea != null){

            nom.setText(tarea.getNombre());
            alias.setText(tarea.getAlia());
            paraje.setText(tarea.getParaje());
            finca.setText(tarea.getFinca());
            titulo.setText(tarea.getTitulo());
            if(tarea.getFecha()!=0){
                fecha.setText(DateFormat.getDateInstance().format(new Date((long) tarea.getFecha())));
                fecha_n.setText(Float.toString(tarea.getFecha()));
            }
            observaciones.setText(tarea.getObservaciones());
            if(tarea.getTiempo()!=0){
                tiempo.setText(Double.toString(tarea.getTiempo()));
            }
            if(tarea.getCoste()!=0){
                coste.setText(Double.toString(tarea.getCoste()));
            }
            s_tiempo.setSelection(tarea.getsTiempo());

        }

        //Implemento los sectores
        Cursor c1 = ConsultaBD.listadoSectores((int) id);

        while(c1.moveToNext()){
            //creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.sector_goteo, null, false);

            //Referencio los textview
            nom_sector = (EditText) nuevoLayout.findViewById(R.id.sector_f_g);
            presio = (EditText) nuevoLayout.findViewById(R.id.pres_f_g);
            abonadora = (EditText) nuevoLayout.findViewById(R.id.abonadora_f_g);
            s_abonadora =(Spinner) nuevoLayout.findViewById(R.id.t_abonadora_f_g);
            layout_pro =   (ViewGroup) nuevoLayout.findViewById(R.id.l_programa);
            identificador_sec = (TextView) nuevoLayout.findViewById(R.id.ids);

            //Pongo el texto en los textview
            int val;
            Double valor;
            nom_sector.setText(c1.getString(c1.getColumnIndex("n_sector")));
            valor=c1.getDouble(c1.getColumnIndex("presio"));
            if(valor!=0) {
                presio.setText(Double.toString(valor));
            }
            val =c1.getInt(c1.getColumnIndex("abonadora"));
            if(val!=0) {
                abonadora.setText(Integer.toString(val));
            }
            s_abonadora.setSelection(c1.getInt(c1.getColumnIndex("t_abonadora")));
            identificador_sec.setText(Integer.toString(c1.getInt(c1.getColumnIndex("sector_id"))));
            ids = c1.getInt(c1.getColumnIndex("sector_id"));

            //Implemento los programas
            Cursor c2 = ConsultaBD.listadoProgramas((int)ids);

            while(c2.moveToNext()){
                //creo el layout del programa
                LayoutInflater inflater2 = LayoutInflater.from(this);
                nuevoLayout2 = (LinearLayout) inflater2.inflate(R.layout.programa_goteo, null, false);

                // Referencio los textView
                dias = (TextView) nuevoLayout2.findViewById(R.id.dias_f_p);
                inicio = (TextView) nuevoLayout2.findViewById(R.id.hora1_f_p);
                fin = (TextView) nuevoLayout2.findViewById(R.id.hora2_f_p);
                inicio_num = (TextView) nuevoLayout2.findViewById(R.id.desde);
                fin_num = (TextView) nuevoLayout2.findViewById(R.id.hasta);
                identificador_pro = (TextView) nuevoLayout2.findViewById(R.id.idp);
                i_desde = (ImageView) nuevoLayout2.findViewById(R.id.imag_desde);
                i_hasta = (ImageView) nuevoLayout2.findViewById(R.id.imag_hasta);

                //pongo el texto el los textviews
                //pongo el texto el los textviews
                long valo;
                dias.setText(c2.getString(c2.getColumnIndex("dias")));
                valo = c2.getLong(c2.getColumnIndex("desde"));
                if(valo!=0){

                    i_desde.setVisibility(View.GONE);
                    inicio.setText(formato.format(new Date(valo)) + " ");
                    inicio_num.setText(Long.toString(0+c2.getLong(c2.getColumnIndex("desde"))));
                }


                valo = c2.getLong(c2.getColumnIndex("hasta"));
                if(valo!=0){
                    i_hasta.setVisibility(View.GONE);
                    fin.setText(formato.format(new Date(valo)) + " ");
                    fin_num.setText(Long.toString(0+c2.getLong(c2.getColumnIndex("hasta"))));
                }

                identificador_pro.setText(Integer.toString(c2.getInt(c2.getColumnIndex("programa_id"))));

                //añado el layout a la vista
                layout_pro.addView(nuevoLayout2);

            }
            c2.close();

            //añado el layout a la vista
            layout_sec.addView(nuevoLayout);



        }

        c1.close();

        /*A continuacion se rellenan los abonos utilizados*/
        Cursor c = ConsultaBD.listadoAbonado((int)id);

        while(c.moveToNext()){
            //Creo el layout
            LayoutInflater inflater = LayoutInflater.from(this);
            nuevoLayout = (LinearLayout) inflater.inflate(R.layout.abono_goteo, null, false);

            //Referencio los textview
            motivo = (EditText) nuevoLayout.findViewById(R.id.motivo_abo);
            nom_comer = (EditText) nuevoLayout.findViewById(R.id.nombre_abo);
            cantidad = (EditText) nuevoLayout.findViewById(R.id.cantidad_abo);
            dosis = (EditText) nuevoLayout.findViewById(R.id.dosis_abo);
            s_dosis = (Spinner) nuevoLayout.findViewById(R.id.s_dosis_a);
            s_cantidad = (Spinner) nuevoLayout.findViewById(R.id.tcantidad_abo);
            identificador = (TextView) nuevoLayout.findViewById(R.id.ida);

            //Pongo el texto en los TextView
            Double valor;
            identificador.setText(Integer.toString(c.getInt(c.getColumnIndex("abonado_id"))));
            motivo.setText(c.getString(c.getColumnIndex("motivo")));
            nom_comer.setText(c.getString(c.getColumnIndex("nombre_a")));
            valor=c.getDouble(c.getColumnIndex("cantidad"));
            if(valor!=0){
                cantidad.setText(Double.toString(valor));
            }
            valor =c.getDouble(c.getColumnIndex("dosis"));
            if(valor!=0){
                dosis.setText(Double.toString(valor));
            }
            s_dosis.setSelection(c.getInt(c.getColumnIndex("dosis_s")));
            s_cantidad.setSelection(c.getInt(c.getColumnIndex("t_cantidad")));

            //Añado el Layout a la vista
            layout.addView(nuevoLayout);


        }

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 126 && resultCode==RESULT_OK) {
            String dias_sel = data.getExtras().getString("dias");
            elec_dias.setText(""+dias_sel);
        }
    }

    @Override
    protected  void onSaveInstanceState(Bundle guardarEstado){
        super.onSaveInstanceState(guardarEstado);
        guardar2();
        guardarEstado.putLong("identificador", id);
        guardarEstado.putBoolean("destruido", true);
    }

    @Override
    protected void onRestoreInstanceState(Bundle recEstado){
        super.onRestoreInstanceState(recEstado);
        layout.removeAllViews();
        layout_sec.removeAllViews();
        rellenarvista2();

    }
    @Override
    public void onBackPressed() {


        new AlertDialog.Builder(this)
                .setTitle("Salir del editor")
                .setMessage("¿Esta seguro que quiere salir sin guardar? todos los cambios se perderan")
                        //.setView(entrada)
                .setPositiveButton("Guardar", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        guardar();
                    }
                })
                .setNegativeButton("Salir", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int whichButton) {
                                cancelar();
                            }
                        }

                )
                .

                        show();

    }
}
