package com.example.ivan.ponsi;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;

/**
 * Created by Ivan on 09/11/2015.
 */
public class ElecAbono extends AppCompatActivity implements AdapterView.OnItemClickListener {

    public AdapadorAbonos adaptador;
    private Button nuevo;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.lista_abonos);

        //creo el list view
        listaAbonos();




    }

   /* @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_propi, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }*/

    public void listaAbonos(){
        ConsultaBD.inicializaBD(this);
        adaptador = new AdapadorAbonos(this, ConsultaBD.listadoAbonos());
        ListView listView = (ListView) findViewById(R.id.list_p);
        listView.setAdapter(adaptador);

        ElecPropietario.setListViewHeightBasedOnChildren(listView);
        listView.setOnItemClickListener(this);
    }





    //Accion a realizar al pulsar el list view
    @Override
    public void onItemClick(AdapterView<?> parent, View vista,
                            int posicion, long id){
        Intent i = new Intent(this, FichaAbono.class);
        i.putExtra("id", id);
        startActivityForResult(i, 125);
    }
    public void nuevoAbono(View view){
        Intent i = new Intent(this, EditarAbono.class);
        i.putExtra("nuevo", true);
        startActivityForResult(i, 125);
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 125) {
            listaAbonos();
        }
    }


}