package com.example.ivan.ponsi;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListAdapter;
import android.widget.ListView;

/**
 * Created by Ivan on 09/11/2015.
 */
public class ElecPropietario extends AppCompatActivity implements AdapterView.OnItemClickListener {

    public AdapadorClientes adaptador;
    private Button nuevo;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.lista_clientes);

        //creo el list view
        listaclientes();



        nuevo = (Button)findViewById(R.id.boton_nuevo_cliente);
        nuevo.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                long id2 = ConsultaBD.nuevoCliente();
                //Toast.makeText(MainActivity.this, "id ="+id2, Toast.LENGTH_LONG).show();
                Intent i = new Intent(ElecPropietario.this,EditarCliente.class);
                i.putExtra("nuevo", true);
                i.putExtra("id", id2);
                startActivityForResult(i,125);
            }
        });

    }

   /* @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_propi, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }*/

    public void listaclientes(){
        ConsultaBD.inicializaBD(this);
        adaptador = new AdapadorClientes(this, ConsultaBD.listadoClientes());
        ListView listView = (ListView) findViewById(R.id.list_c);
        listView.setAdapter(adaptador);

        ElecPropietario.setListViewHeightBasedOnChildren(listView);
        listView.setOnItemClickListener(this);
    }


    /**** Method for Setting the Height of the ListView dynamically.
     **** Hack to fix the issue of not showing all the items of the ListView
     **** when placed inside a ScrollView  ****/
    public static void setListViewHeightBasedOnChildren(ListView listView) {

        ListAdapter listAdapter = listView.getAdapter();
        if (listAdapter == null)
            return;

        int desiredWidth = View.MeasureSpec.makeMeasureSpec(listView.getWidth(), View.MeasureSpec.UNSPECIFIED);
        int totalHeight = 0;
        View view = null;
        for (int i = 0; i < listAdapter.getCount(); i++) {
            view = listAdapter.getView(i, view, listView);
            if (i == 0)
                view.setLayoutParams(new ViewGroup.LayoutParams(desiredWidth, ViewGroup.LayoutParams.WRAP_CONTENT));

            view.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);
            totalHeight += view.getMeasuredHeight();
        }
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight +100+ (listView.getDividerHeight() * (listAdapter.getCount() -1));
        listView.setLayoutParams(params);
        listView.requestLayout();
    }


    //Accion a realizar al pulsar el list view
    @Override
    public void onItemClick(AdapterView<?> parent, View vista,
                            int posicion, long id){
        Intent i = new Intent(this, FichaCliente.class);
        i.putExtra("id", id);
        startActivityForResult(i, 125);
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 125) {
            listaclientes();
        }
    }


}