package com.example.ivan.ponsi;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;


public class ElegirTarea extends AppCompatActivity {
    Button cancel, ok;
    Spinner tipoTarea;
    long idp;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tipo_tarea);
        Bundle extras = getIntent().getExtras();
        idp = extras.getLong("idp",-1);  //id es el identificador de la parcela



        //creo he inicializo el spinner
        tipoTarea = (Spinner) findViewById(R.id.selector_tarea);
        ArrayAdapter<String> adaptador2 = new ArrayAdapter<String>(this,
                android.R.layout.simple_spinner_item, ConsultaBD.getTipoTareas());
        adaptador2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        tipoTarea.setAdapter(adaptador2);
        tipoTarea.setSelection(0);

        //Activo la funcionalidad de los botones
        //boton cancelar
        cancel = (Button)findViewById(R.id.boton_cancelar);
        cancel.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
            }
        });

        //Boton Confirmar tipo tarea
        ok = (Button)findViewById(R.id.boton_confirmar);
        ok.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                int a=ConsultaBD.getTipoTarea(tipoTarea.getSelectedItemPosition());

                long id2 = ConsultaBD.nuevaTarea((int) idp, a);
                Intent i = new Intent(ElegirTarea.this,EditarTareaFito.class);;



                switch (a){
                    case 1:
                        i = new Intent(ElegirTarea.this,EditarTareaFito.class);
                        break;
                    case 2:
                        i = new Intent(ElegirTarea.this,EditarTareaOtros.class);
                        break;
                    case 3:
                        i = new Intent(ElegirTarea.this,EditarTareaAbono.class);
                        break;
                    case 4:
                        i = new Intent(ElegirTarea.this,EditarTareaGoteo.class);
                        break;

                }
                i.putExtra("nuevo", true);
                i.putExtra("id", id2);
                startActivity(i);
                finish();
            }
        });

    }
}
