package com.example.ivan.ponsi;

import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.URLUtil;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by Ivan on 20/10/2015.
 */
public class AdapadorAbonos extends CursorAdapter {
    private LayoutInflater inflador;
    TextView nombre;
    ImageView foto;

    public AdapadorAbonos(Context contexto, Cursor c){
        super(contexto, c, false);
    }

    @Override
    public View newView(Context contexto, Cursor c, ViewGroup padre){
        inflador = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vista = inflador.inflate(R.layout.elemento_lista_abonos, padre,false);
        return vista;
    }

    @Override
    public void bindView(View vista, Context contexto, Cursor c) {
        int a;

        nombre = (TextView) vista.findViewById(R.id.nombre_l_p_f);


        foto = (ImageView) vista.findViewById(R.id.foto_cliente_list);


        nombre.setText(c.getString(c.getColumnIndex("nombre_a")));




                foto.setImageResource(R.drawable.otros_fito);







        String fotos = c.getString(c.getColumnIndex("imagen_p"));
        if (URLUtil.isValidUrl(fotos)) {

            foto.setImageURI(Uri.parse(fotos));
        }else{
            foto.setImageResource(R.drawable.otros_fito);
        }
        //foto.setScaleType(ImageView.ScaleType.FIT_END);

    }
}
