package com.example.ivan.ponsi;

import android.content.Context;
import android.database.Cursor;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;

import java.text.DateFormat;
import java.util.Date;

/**
 * Created by Ivan on 20/10/2015.
 */
public class AdaptadorTareasPendientes extends CursorAdapter {
    private LayoutInflater inflador;
    TextView nombre, alias, finca, paraje, titulo,fecha, prova;
    ImageView icono;
    RatingBar prioridad;

    public AdaptadorTareasPendientes(Context contexto, Cursor c){
        super(contexto, c, false);
    }

    @Override
    public View newView(Context contexto, Cursor c, ViewGroup padre){
        inflador = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vista = inflador.inflate(R.layout.elemento_lista_tareas_pendientes, padre,false);
        return vista;
    }

    @Override
    public void bindView(View vista, Context contexto, Cursor c) {

        int a;
        nombre = (TextView) vista.findViewById(R.id.nombre_l_t_p);
        alias = (TextView) vista.findViewById(R.id.alias_l_t_p);
        finca = (TextView) vista.findViewById(R.id.finca_l_t_p);
        paraje = (TextView) vista.findViewById(R.id.paraje_l_t_p);
        titulo = (TextView) vista.findViewById(R.id.titulo_list);
        fecha = (TextView) vista.findViewById(R.id.fecha_list);
        icono = (ImageView) vista.findViewById(R.id.icono_tarea_list);
        prioridad = (RatingBar) vista.findViewById(R.id.prioridad_list);




        a = c.getInt(c.getColumnIndex("tipo"));
        titulo.setText(c.getString(c.getColumnIndex("titulo")));
        fecha.setText(DateFormat.getDateInstance().format(new Date(c.getLong(c.getColumnIndex("fecha")))));
        nombre.setText(c.getString(c.getColumnIndex("nombre")) + " " + c.getString(c.getColumnIndex("apellidos")));
        alias.setText(c.getString(c.getColumnIndex("alias")));
        finca.setText(c.getString(c.getColumnIndex("finca")));
        paraje.setText(c.getString(c.getColumnIndex("paraje")));
        prioridad.setRating(c.getFloat(c.getColumnIndex("prioridad")));




        switch (a){
            case 0:

                icono.setImageResource(R.drawable.fito);
                break;
            case 3:

                icono.setImageResource(R.drawable.otros);
                break;
            case 1:

                icono.setImageResource(R.drawable.abonado);
                break;
            case 2:

                icono.setImageResource(R.drawable.goteo);
                break;



        }



        //foto.setScaleType(ImageView.ScaleType.FIT_END);

    }
}


