package com.example.ivan.ponsi;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

public class Inicio extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.inicio);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_inicio, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.informacion) {
            Intent i = new Intent(this, InformacionInicio.class);
            startActivity(i);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void esPropietario(View view){
        Intent i = new Intent(this, ElecPropietario.class);
        startActivity(i);
    }

    public void esTareaPendiente(View view){
        Intent i = new Intent(this, ElecTareaPen.class);
        startActivity(i);
    }
    public void esProFito(View view){
        Intent i = new Intent(this, ElecProducto.class);
        startActivity(i);
    }
    public void esAbono(View view){
        Intent i = new Intent(this, ElecAbono.class);
        startActivity(i);
    }
    public void esBuscar(View view){
        enConstruccion();
    }

    public  void enConstruccion(){
        Intent i = new Intent(this, EnConstruccion.class);
        startActivity(i);
    }


}
